# coding: utf-8

"""
REDACcess User API

This API provides functionalities to interact with a deployed anabrid REDAC system, including hardware status checks, job submission, job status retrieval, and result downloads. Also supports streaming of results by attaching to endpoints.

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from anabrid.redaccess.api.common.models.gen.cluster_config import ClusterConfig
from anabrid.redaccess.api.common.models.gen.t_block_config import TBlockConfig

try:
    from typing import Self
except ImportError:
    from typing_extensions import Self


class CarrierConfig(BaseModel):
    """
    CarrierConfig
    """  # noqa: E501

    adc_channels: List[StrictInt]
    st0: Optional[TBlockConfig] = Field(None, alias="/ST0")
    st1: Optional[TBlockConfig] = Field(None, alias="/ST1")
    t: TBlockConfig = Field(None, alias="/T")
    c0: Optional[ClusterConfig] = Field(None, alias="/0")
    c1: Optional[ClusterConfig] = Field(None, alias="/1")
    c2: Optional[ClusterConfig] = Field(None, alias="/2")
    __properties: ClassVar[List[str]] = [
        "adc_channels",
        "st0",
        "st1",
        "t",
        "c0",
        "c1",
        "c2",
    ]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CarrierConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CarrierConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "adc_channels": obj.get("adc_channels"),
                "/ST0": (
                    TBlockConfig.from_dict(obj.get("/ST0"))
                    if obj.get("/ST0") is not None
                    else None
                ),
                "/ST1": (
                    TBlockConfig.from_dict(obj.get("/ST0"))
                    if obj.get("/ST0") is not None
                    else None
                ),
                "/T": (
                    TBlockConfig.from_dict(obj.get("/T"))
                    if obj.get("/T") is not None
                    else None
                ),
                "/0": (
                    ClusterConfig.from_dict(obj.get("/0"))
                    if obj.get("/0") is not None
                    else None
                ),
                "/1": (
                    ClusterConfig.from_dict(obj.get("/1"))
                    if obj.get("/1") is not None
                    else None
                ),
                "/2": (
                    ClusterConfig.from_dict(obj.get("/2"))
                    if obj.get("/2") is not None
                    else None
                ),
            }
        )

        return _obj
